<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                xmlns:f="http://xmlns.jcp.org/jsf/core"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                template="./../plantilla-principal.xhtml"
                xmlns:c="http://xmlns.jcp.org/jsp/jstl/core">

    <ui:define name="contenido">
        <h:form prependId="false" class="ui menu">
            <div class="header borderless item">
                <div style="font-size: 22px">
                    <i class="sticky note outline icon" />
                    Nueva factura
                </div>
            </div>

            <div class="right menu">
                <div class="#{newBillManBean.facturaNueva?'ui borderless category search calendar item':'ui disabled borderless category search calendar item'}" id="example2" >
                    <div id="inputFechaFactura" style="width: 130px; height: 38px" class="ui input left icon" data-tooltip="Fecha de la factura" data-inverted="" data-position="bottom center">
                        <i class="calendar icon"></i>
                        <h:inputText id="in-fechafact" value="#{newBillManBean.strFechaFactura}" pt:placeholder="Fecha" />
                    </div>
                </div>
                <div class="borderless item">
                    <div jsf:id="inputFactura" style="margin-left: -22px;height: 38px" class="#{newBillManBean.facturaNueva?'ui labeled input':'ui disabled labeled input'}" data-tooltip="Número de factura" data-inverted="" data-position="bottom right">
                        <div id="cmbTalonarioFactura" class="ui dropdown label #{not newBillManBean.facturaNueva?'disabled':''}">
                            <h:inputHidden id="in-idtalonario" value="#{newBillManBean.idTalonarioSeleccionado}" />
                            <div class="text">--- ---</div>
                            <i class="dropdown icon"></i>
                            <div class="menu">
                                <ui:repeat value="#{newBillManBean.lstTalonariosActivos}" var="talon" varStatus="talonStatus">
                                    <div data-tooltip="
                                         Actual: #{talon.nroActual} |
                                         Fin: #{talon.nroFin} |
                                         Disp: #{talon.nroFin-talon.nroActual}"
                                         data-inverted="" 
                                         data-position="left center" 
                                         class="item" data-value="#{talon.idtalonario}">
                                        #{talon.codEstablecimiento}
                                    </div>
                                </ui:repeat>
                            </div>
                        </div>
                        <h:inputText id="in-numerofactura" style="width: 122px" pt:type="number" pt:placeholder="Número" value="#{newBillManBean.nroFacturaActual}" />
                    </div>
                    <h:commandLink id="cmlActNumeroFactura" action="#{newBillManBean.actualizarNumeracionTalonario()}">
                        <f:ajax execute="in-idtalonario @this" render="in-numerofactura" />
                    </h:commandLink>
                </div>
                <div class="borderless item">
                    <div style="margin-top: -4px; margin-bottom: -4px;margin-left: -22px; width: 400px" id="cmbCliente" class="#{newBillManBean.facturaNueva?'ui search selection dropdown':'ui disabled search selection dropdown'}" >
                        <h:inputHidden id="in-idclienteagregar" value="#{newBillManBean.idCliente}" />
                        <i class="dropdown icon" />
                        <div class="default text">Cliente</div>
                        <div class="menu">
                        </div>
                    </div>
                    <h:commandLink id="cmlSelecCli" action="#{newBillManBean.seleccionarCliente()}" style="display: none">
                        <f:ajax execute="@form" render="form-cuotas form-otroscobros form-detallefactura" onevent="function(data){ajaxAgregarCliente(data)}" />
                    </h:commandLink>
                </div>
                <div class="item">
                    <h:commandLink style="#{not newBillManBean.facturaNueva?'display: none;':''}" class="ui icon button" action="#{newBillManBean.nuevaFactura()}" pt:data-tooltip="Limpiar campos" pt:data-inverted="" pt:data-position="bottom right">
                        <i class="erase icon" />
                        <f:ajax execute="@this" render="tabla-detallefactura form-cuotas form-otroscobros @form" onevent="function(data){ajaxNuevaFactura(data)}" />
                    </h:commandLink>
                    <h:commandLink style="margin-left: 5px;#{newBillManBean.facturaNueva?'display: none;':''}" action="#{newBillManBean.generarPDF()}" class="ui icon button" pt:data-tooltip="Vista previa" pt:data-inverted="" pt:data-position="bottom right">
                        <i class="print icon" />
                    </h:commandLink>
                    <h:commandLink style="margin-left: 5px; #{newBillManBean.facturaNueva?'display: none;':''}" class="ui green icon button" action="#{newBillManBean.nuevaFactura()}" pt:data-tooltip="Nueva factura" pt:data-inverted="" pt:data-position="bottom right">
                        <i class="add icon" />
                        <f:ajax execute="@this" render="tabla-detallefactura form-cuotas form-otroscobros @form" onevent="function(data){ajaxNuevaFactura(data)}" />
                    </h:commandLink>
                    <h:commandLink class="ui blue icon button" style="margin-left: 5px; #{newBillManBean.facturaNueva?'':'display: none;'}" pt:data-tooltip="Guardar factura" pt:data-inverted="" pt:data-position="bottom right" action="#{newBillManBean.guardarFactura()}" onclick="return validarFactura();">
                        <i class="save icon" />
                        <f:ajax execute="@form" render="in-tipomsg cabeceraMsg cuerpoMsg tabla-detallefactura form-cuotas form-otroscobros @form" onevent="function(data){ajaxGuardarFactura(data)}" />
                    </h:commandLink>
                </div>
            </div>
        </h:form>
        <div class="ui grid">
            <div class="nine wide column">
                <h:form id="form-detallefactura" prependId="false">
                    <table jsf:id="tabla-detallefactura" class="ui blue table">
                        <thead>
                            <tr>
                                <th>Concepto</th>
                                <th class="collapsing right aligned">Cant.</th>
                                <th class=" collapsing right aligned">Monto</th>
                                <th class=" rignt aligned collapsing"></th>
                            </tr>
                        </thead>
                        <tbody>
                            <ui:repeat value="#{newBillManBean.lstDetalleFactura}" var="detfac" varStatus="detfacStatus">
                                <tr class="#{not newBillManBean.facturaNueva?'disabled':''}">
                                    <td data-tooltip="#{detfac.suscripcion.barrio.nombre} - #{detfac.suscripcion.direccion}" data-inverted="">
                                        <h:outputText value="#{detfac.descripcion}" />
                                    </td>
                                    <td class="right aligned">
                                        <h:outputText value="#{detfac.cantidad}">
                                            <f:convertNumber pattern="#,###,###,###" />
                                        </h:outputText>
                                    </td>
                                    <td class="right aligned">
                                        <h:outputText value="#{detfac.subtotal}">
                                            <f:convertNumber pattern="#,###,###,###" />
                                        </h:outputText>
                                    </td>
                                    <td class=" right aligned collapsing">
                                        <h:commandLink action="#{newBillManBean.quitarDetalleFactura(detfacStatus.index)}">
                                            <i class="red times circle icon" />
                                            <f:ajax execute="@this" render="@form form-cuotas" />
                                        </h:commandLink>
                                    </td>
                                </tr>
                            </ui:repeat>
                            <tr class="center aligned disabled" jsf:rendered="#{empty newBillManBean.lstDetalleFactura}">
                                <td colspan="4">(Ningún detalle)</td>
                            </tr>
                        </tbody>
                        <tfoot>
                            <tr>
                                <th colspan="2" style="font-weight: bold;">TOTAL</th>
                                <th style="font-weight: bold" class="red right aligned">
                                    <h:outputText value="#{newBillManBean.totalFactura}">
                                        <f:convertNumber pattern="#,###,###,###" />
                                    </h:outputText>
                                </th>
                                <th ></th>
                            </tr>
                        </tfoot>
                    </table>
                </h:form>
                <h:form prependId="false">
                    <div id="msg" class="ui hidden success message">
                        <h:inputText style="display: none;" id="in-tipomsg" value="#{newBillManBean.tipoMsg}" />
                        <i class="close icon"></i>
                        <div class="header">
                            <h:outputText id="cabeceraMsg" value="#{newBillManBean.cabeceraMsg}" />                        
                        </div>
                        <p><h:outputText id="cuerpoMsg" value="#{newBillManBean.cuerpoMsg}" /></p>
                    </div>
                </h:form>
            </div>

            <div class="seven wide column">

                <div class="ui segments">
                    <div class="ui horizontal segments menu">
                        <a id="tabCuotas" class="ui segment active item" data-tab="cuotas">
                            Cuotas
                        </a>
                        <a id="tabOtrosCobros" class="ui segment item" data-tab="otroscobros">
                            Otros cobros
                        </a>
                    </div>
                    <div class="ui tab active green segment" data-tab="cuotas">
                        <h:form prependId="false" id="form-cuotas">
                            <ui:repeat value="#{newBillManBean.suscripciones}" var="susc" varStatus="suscStatus">
                                <table class="ui very basic single line green table">
                                    <thead>
                                        <tr>
                                            <th colspan="2">
                                                <h:outputText pt:data-tooltip="Barrio: #{susc.barrio.nombre} | Dirección: #{susc.direccion}" pt:data-inverted="" pt:data-position="left center" value="#{susc.idsuscripcion} - #{susc.servicio.nombre} (#{susc.estado.nombre})"/>
                                            </th>
                                            <th class="collapsing right aligned">
                                                <h:outputText value="#{susc.precio}">
                                                    <f:convertNumber pattern="#,###,###,###" />
                                                </h:outputText>/mes
                                            </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <ui:repeat value="#{newBillManBean.getCuotasPendientes(susc.idsuscripcion)}" var="cuo" varStatus="cuoStatus">
                                            <tr class="#{not newBillManBean.facturaNueva?'disabled':''}">
                                                <td>
                                                    <span data-tooltip="Factura pendiente: #{newBillManBean.getNroFacturaPendiente(cuo.idcuota)}" data-inverted="" data-position="left center">
                                                        <i jsf:rendered="#{newBillManBean.existeFacturaPendiente(cuo.idcuota)}" class="minus circle icon" />
                                                    </span>
                                                    <h:commandLink rendered="#{not newBillManBean.existeFacturaPendiente(cuo.idcuota) &amp;&amp; !cuo.cancelado}" action="#{newBillManBean.agregarCuota(cuo.idcuota)}">
                                                        <i class="green plus circle icon" />
                                                        <f:ajax execute="@this" render="@form tabla-detallefactura" />
                                                    </h:commandLink>
                                                    <h:commandLink rendered="#{not newBillManBean.existeFacturaPendiente(cuo.idcuota) &amp;&amp; cuo.cancelado}" action="#{newBillManBean.agregarCuota(cuo.idcuota)}"  pt:data-tooltip="Pagado sin factura. #{newBillManBean.getDatosPago(cuo.idcuota)}" pt:data-inverted="" pt:data-position="left center">
                                                        <i class="orange plus circle icon" />
                                                        <f:ajax execute="@this" render="@form tabla-detallefactura" />
                                                    </h:commandLink>
                                                    <h:outputText value="Cuota #{utilConversion.getNombreMesCorto(cuo.mesCuota)}/#{cuo.anioCuota}" rendered="#{cuo.servicio.idservicio==cuo.suscripcion.servicio.idservicio}" />
                                                    <h:outputText value="#{cuo.servicio.nombre} #{cuo.nroCuota}/#{cuo.historialGeneracion.cantidadCuotas}" rendered="#{cuo.servicio.idservicio!=cuo.suscripcion.servicio.idservicio}" />
                                                </td>
                                                <td>
                                                    <h:outputText value="#{cuo.fechaVencimiento}">
                                                        <f:convertDateTime pattern="dd/MMM/yyyy" />
                                                    </h:outputText>
                                                </td>
                                                <td class="right aligned">
                                                    <h:outputText value="#{cuo.montoCuota}">
                                                        <f:convertNumber pattern="#,###,###,###" />
                                                    </h:outputText>
                                                </td>
                                            </tr>
                                        </ui:repeat>
                                        <tr jsf:rendered="#{empty newBillManBean.getCuotasPendientes(susc.idsuscripcion)}" class="center aligned disabled">
                                            <td colspan="3">(Sin cuotas pendientes)</td>
                                        </tr>
                                    </tbody>
                                </table>
                            </ui:repeat>
                            <table jsf:rendered="#{empty newBillManBean.suscripciones}" class="ui very basic table">
                                <tbody>
                                    <td class="center aligned disabled">(Ninguna cuota)</td>
                                </tbody>
                            </table>
                        </h:form>
                    </div>
                    <div  class="ui tab red segment" data-tab="otroscobros">
                        <h:form id="form-otroscobros" prependId="false">
                            <div id="cmbSuscripcionOtrosCobros" class="ui fluid selection dropdown">
                                <h:inputHidden id="in-idsuscotroscobros" value="#{newBillManBean.idSuscripcionOtrosCobros}" />
                                <i class="dropdown icon"></i>
                                <div class="default text">Suscripción</div>
                                <div class="menu">
                                    <ui:repeat value="#{newBillManBean.suscripciones}" var="suscserv" varStatus="suscservStatus">
                                        <div class="item" data-value="#{suscserv.idsuscripcion}">
                                            #{suscserv.idsuscripcion} - #{suscserv.servicio.nombre}
                                        </div>
                                    </ui:repeat>
                                </div>
                            </div>
                            <div id="msgAgregarOtroCobro" class="ui hidden error message">
                                <i class="close icon"></i>
                                <div class="header">
                                    Campo requerido
                                </div>
                                <ul class="list">
                                    Seleccione una suscripción.
                                </ul>
                            </div>
                            <table class="ui very basic table">
                                <thead>
                                    <tr>
                                        <th>Concepto</th>
                                        <th class="collapsing right aligned">Monto</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <ui:repeat value="#{newBillManBean.serviciosNoSuscribibles}" var="otrosServ" varStatus="otrosServStatus">
                                        <tr class="#{not newBillManBean.facturaNueva?'disabled':''}">
                                            <td>
                                                <h:commandLink onclick="return validarAgregarOtrosCobros()" action="#{newBillManBean.agregarOtrosCobros(otrosServ.idservicio)}">
                                                    <f:ajax execute="@form" render="form-detallefactura" />
                                                    <i class="green plus circle icon" />
                                                </h:commandLink>
                                                #{otrosServ.nombre}
                                            </td>
                                            <td>
                                                <h:outputText value="#{otrosServ.precio}">
                                                    <f:convertNumber pattern="#,###,###,###" />
                                                </h:outputText>
                                            </td>
                                        </tr>
                                    </ui:repeat> 
                                </tbody>
                            </table>
                        </h:form>
                    </div>
                </div>

            </div>
            <h:form prependId="false">
                <h:inputHidden id="in-idterminal" value="#{newBillManBean.idTerminalAsignada}" />
                <h:commandLink style="display: none;" id="cmlActualizarTalonario" action="#{newBillManBean.actualizarTalonario()}">
                    <f:ajax execute="@form" render="inputFactura" onevent="function(data){ajaxActualizarTalonario(data)}" />
                </h:commandLink>
            </h:form>
        </div>
        <h:outputScript target="body" library="js" name="facturas/nuevafactura.js" />
    </ui:define>

</ui:composition>
